/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of SHA2.xs. Do not edit this file, edit SHA2.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "SHA2.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"
#include "_sha2.c"

typedef struct sha2 {
    SHA256_CTX ctx256;
    SHA384_CTX ctx384;
    SHA512_CTX ctx512;
    int digestsize;
    int rounds;
}* Digest__SHA2;

#line 25 "SHA2.c"
XS(XS_Digest__SHA2_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA2_new)
{
    dXSARGS;
    if (items < 1 || items > 2)
	Perl_croak(aTHX_ "Usage: Digest::SHA2::new(class, hashlength=256)");
    {
	int	hashlength;
	Digest__SHA2	RETVAL;

	if (items < 2)
	    hashlength = 256;
	else {
	    hashlength = (int)SvIV(ST(1));
	}
#line 23 "SHA2.xs"
    {
        switch (hashlength) {
            case 256:
            case 384:
            case 512:
                break;

            default:
                croak("\nAcceptable hash sizes are 256, 384, and 512 only\n");
                break;
        }

        Newz(0, RETVAL, 1, struct sha2);
        RETVAL->digestsize = hashlength;
        RETVAL->rounds = 1;

        switch (RETVAL->digestsize) {
            case 256:
                SHA256_Init(&RETVAL->ctx256);
                break;

            case 384:
                SHA384_Init(&RETVAL->ctx384);
                break;

            case 512:
                SHA512_Init(&RETVAL->ctx512);
                break;
        }
    }

#line 73 "SHA2.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Digest::SHA2", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Digest__SHA2_clone); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA2_clone)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA2::clone(self)");
    {
	Digest__SHA2	self;
	Digest__SHA2	RETVAL;

	if (sv_derived_from(ST(0), "Digest::SHA2")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Digest__SHA2,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Digest::SHA2");
#line 62 "SHA2.xs"
    {
        Newz(0, RETVAL, 1, struct sha2);
        Copy(self, RETVAL, 1, struct sha2);
    }

#line 102 "SHA2.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Digest::SHA2", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Digest__SHA2_hashsize); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA2_hashsize)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA2::hashsize(self)");
    {
	Digest__SHA2	self;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Digest::SHA2")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Digest__SHA2,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Digest::SHA2");
#line 74 "SHA2.xs"
        RETVAL = self->digestsize;

#line 129 "SHA2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Digest__SHA2_rounds); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA2_rounds)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA2::rounds(self)");
    {
	Digest__SHA2	self;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Digest::SHA2")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Digest__SHA2,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Digest::SHA2");
#line 83 "SHA2.xs"
        RETVAL = self->rounds;

#line 155 "SHA2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Digest__SHA2_reset); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA2_reset)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA2::reset(self)");
    {
	Digest__SHA2	self;

	if (sv_derived_from(ST(0), "Digest::SHA2")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Digest__SHA2,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Digest::SHA2");
#line 92 "SHA2.xs"
    {
        switch (self->digestsize) {
            case 256:
                SHA256_Init(&self->ctx256);
                break;

            case 384:
                SHA384_Init(&self->ctx384);
                break;

            case 512:
                SHA512_Init(&self->ctx512);
                break;
        }
    }
#line 192 "SHA2.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Digest__SHA2_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA2_add)
{
    dXSARGS;
    if (items < 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA2::add(self, ...)");
    {
	Digest__SHA2	self;

	if (sv_derived_from(ST(0), "Digest::SHA2")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Digest__SHA2,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Digest::SHA2");
#line 112 "SHA2.xs"
    {
        STRLEN len;
        unsigned char* data;
        unsigned int i;

        for (i = 1; i < items; i++) {
            data = (unsigned char*)(SvPV(ST(i), len));

            switch (self->digestsize) {
                case 256:
                    SHA256_Update(&self->ctx256, data, len);
                    break;

                case 384:
                    SHA384_Update(&self->ctx384, data, len);
                    break;

                case 512:
                    SHA512_Update(&self->ctx512, data, len);
                    break;
            }
        }
    }
#line 236 "SHA2.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Digest__SHA2_hexdigest); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA2_hexdigest)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA2::hexdigest(self)");
    {
	Digest__SHA2	self;
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Digest::SHA2")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Digest__SHA2,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Digest::SHA2");
#line 140 "SHA2.xs"
    {
        RETVAL = newSVpv("", 64);  /* defaults to SHA-256 */

        switch (self->digestsize) {
            case 256:
                SHA256_End(&self->ctx256, SvPV_nolen(RETVAL));
                break;

            case 384:
                RETVAL = newSVpv("", 96);
                SHA384_End(&self->ctx384, SvPV_nolen(RETVAL));
                break;

            case 512:
                RETVAL = newSVpv("", 128);
                SHA512_End(&self->ctx512, SvPV_nolen(RETVAL));
                break;
        }
    }

#line 278 "SHA2.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_Digest__SHA2_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Digest__SHA2_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Digest::SHA2::DESTROY(self)");
    {
	Digest__SHA2	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Digest__SHA2,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not a reference");
#line 167 "SHA2.xs"
        Safefree(self);
#line 302 "SHA2.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Digest__SHA2); /* prototype to pass -Wmissing-prototypes */
XS(boot_Digest__SHA2)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXS("Digest::SHA2::new", XS_Digest__SHA2_new, file);
        newXS("Digest::SHA2::clone", XS_Digest__SHA2_clone, file);
        newXS("Digest::SHA2::hashsize", XS_Digest__SHA2_hashsize, file);
        newXS("Digest::SHA2::rounds", XS_Digest__SHA2_rounds, file);
        newXS("Digest::SHA2::reset", XS_Digest__SHA2_reset, file);
        newXS("Digest::SHA2::add", XS_Digest__SHA2_add, file);
        newXS("Digest::SHA2::hexdigest", XS_Digest__SHA2_hexdigest, file);
        newXS("Digest::SHA2::DESTROY", XS_Digest__SHA2_DESTROY, file);
    XSRETURN_YES;
}

